package arith_debug;

import java.io.IOException;
import java.io.FileReader;
import java.io.FileNotFoundException;

%%

%public
%class	Scanner
%implements arith_debug.Arith.yyInput

%type	int
%eofval{
	return YYEOF;
%eofval}

%{
    private int token;

    /** move on to next token.
        @returns false if positioned beyond tokens.
        @throws IOException on input error.
      */
    public boolean advance () throws java.io.IOException {
	  token=yylex();
	  return token != YYEOF;
    }

    /** classifies current token.
        Should not be called if advance() returned false.
        @returns current %token or single character.
      */
    public int token () {
	  return token;
    }

    /** associated with current token.
        Should not be called if advance() returned false.
        @returns value for token().
      */
    public Object value () {
	  return value;
    }

    Number value;
%}

comment	= ("#".*)
space	= [\ \t\b\015]+
digit	= [0-9]
integer	= {digit}+
real	= ({digit}+"."{digit}*|{digit}*"."{digit}+)

%%

{space}|{comment}	{ }
{integer}		{ value = new Long(yytext()); return Arith.Constant; }
{real}			{ value = new Double(yytext()); return Arith.Constant; }
.|\n			{ value=null; return yytext().charAt(0); }
